#include once "2dMathf.bi"
#include once "world.bi"

enum node_state

	nNone
	nClosed
	nOpen
	
end enum


enum status_state
	
	nSuccess
	nBadStart
	nBadEnd
	nIncomplete
	
end enum


type NavNode
	
	as integer x
	as integer y
	as integer c
	as integer f
	as integer g
	as integer h
	as integer p
	
	as integer blocked
	as integer state
	as navnode ptr parent
	
end type


type NavGrid
	
	as integer startX
	as integer startY
	as integer endX
	as integer endY
	
	as integer maxX
	as integer maxY
		
	as integer useTerrainBias = true
	
	as NavNode gNode(any, any)
		
	declare sub update_node_map( byref map as WorldStruct )
	
	declare function find_path( byref entity as EntityStruct, byref origin as vec2i, byref target as vec2i) as integer
	
	declare sub blend_bias_map()
	
	private:
	
	declare function get_lowF() as navnode ptr
	
	declare function eval_node( byval parent as navNode ptr, byval x as integer, byval y as integer, byval gCost as integer ) as integer
	
	declare sub eval_chunk( byval parent as navnode ptr, byval x as integer, byval y as integer )
	
end type



