#include once "world.bi"


constructor EntityStruct()

	image = png_load("res\textures\characters\dude.png", PNG_TARGET_FBNEW)
	
	dim as string path =  "res\textures\characters\peasant_man\walk\"
	
	for d as integer = 0 to 7
		
		dim as string filename
		dim as vec2f tVec
		
		select case as const d
			
			case 0
				filename = "walk_w"
				tVec = vec2f(-1,0)
			case 1
				filename = "walk_nw"
				tVec = vec2f(-1,-1)
			case 2
				filename = "walk_n"
				tVec = vec2f(0,-1)
			case 3
				filename = "walk_ne"
				tVec = vec2f(1,-1)
			case 4
				filename = "walk_e"
				tVec = vec2f(1,0)
			case 5
				filename = "walk_se"
				tVec = vec2f(1,1)
			case 6
				filename = "walk_s"
				tVec = vec2f(0,1)
			case 7
				filename = "walk_sw"
				tVec = vec2f(-1,1)
		end select
		
		dr(d) = tVec
		
		for f as integer = 0 to 15
			
			dim as string nfilename
			
			if f<9 then
				nfilename = filename + "00" & f+1 & ".png"
			else
				nfilename = filename + "0" & f+1 & ".png"
			end if
			
			walk(d,f) = png_load( path+nfilename, PNG_TARGET_FBNEW)
			
		next
		
	next
	
end constructor

destructor EntityStruct()

	png_destroy(image)
	
	for d as integer = 0 to 7
		for f as integer = 0 to 15
			png_destroy(walk(d,f))
		next
	next
	
end destructor


sub pathstruct.add(np as vec2i)

	dim as integer cnt = ubound(p)
	
	redim preserve p (cnt+1)
	
	p(cnt+1) = np

end sub


sub drawmap( map as WorldStruct )

	for y as integer = 0 to ubound(map.tile, 2)
		
		for x as integer = 0 to ubound(map.tile, 1)

			dim as integer x1 = x*SCALE
			dim as integer y1 = y*SCALE
			
			put(x1, y1), map.image(map.tile(x, y).ID)
			
			with map.tile(x,y)
				
				if .ID=0 then
					
					line(x1+1,y1+1)-step(scale-2,scale-2), rgba(0, 0, 64,32), b
					
				else
					
					line(x1+1,y1+1)-step(scale-2,scale-2), rgba(0, 0, 0,32), b
					
				end if
				
			end with
			
		next
		
	next

end sub


sub drawcharacter(dude as EntityStruct)
	
	select case as const dude.action
		
		case walk
			
			put( dude.p.x-8, dude.p.y-16), dude.walk(dude.direction, int(dude.fcntr)),alpha
			
		
	end select

end sub